/*---------------------------------------------------------------------------------
 bbWheelHook 0.0.2 ( 2006 nocd5)
 ----------------------------------------------------------------------------------
 bbWheelHook is a plugin for bbLean
 ----------------------------------------------------------------------------------
 bbWheelHook is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#include "bbWheelHook.h"
//-------------------------------------------------------------------------------------

int beginPlugin(HINSTANCE hPluginInstance){
	WNDCLASS wc;
	ZeroMemory((void*)&wc, sizeof(wc));
	wc.lpszClassName = pluginInfo(0);
	wc.hInstance = hPluginInstance;
	wc.lpfnWndProc = DefWindowProc;
	RegisterClass(&wc);

	hPluginWnd = CreateWindow(
		pluginInfo(0),
		NULL,
		WS_POPUP,
		0, 0, 0, 0,
		HWND_MESSAGE,
		NULL,
		hPluginInstance,
		NULL
	);
	g_hWHook = SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)WheelProc, hPluginInstance, 0);
	BBhWnd = (HWND)GetCurrentProcess();
	SendMessage(BBhWnd, BB_REGISTERMESSAGE, (WPARAM)hPluginWnd, (LPARAM)bb_messages);
	return 0;
}

//-------------------------------------------------------------------------------------

void endPlugin(HINSTANCE hPluginInstance){
	SendMessage(BBhWnd, BB_UNREGISTERMESSAGE, (WPARAM)hPluginWnd, (LPARAM)bb_messages);
	DestroyWindow(hPluginWnd);
	UnregisterClass(pluginInfo(0), hPluginInstance);
	HookUninstall();
}

//-------------------------------------------------------------------------------------
LRESULT CALLBACK WheelProc(int nCode, WPARAM wParam, LPARAM lParam){
	MSG *msg = (MSG *)lParam;
	if(nCode == HC_ACTION){
		if(LOWORD(msg->message) == WM_MOUSEWHEEL){
			HWND pt_hwnd = WindowFromPoint(msg->pt);
			if(pt_hwnd != msg->hwnd) {
				SendMessage(pt_hwnd, WM_MOUSEWHEEL, msg->wParam, msg->lParam);
				msg->message = WM_NULL;
				return 0;
			}
		}
	}
	return CallNextHookEx(g_hWHook, nCode, wParam, lParam);
}

//-------------------------------------------------------------------------------------
void CALLBACK HookUninstall(){
	if (g_hWHook != NULL){
		UnhookWindowsHookEx(g_hWHook);
		g_hWHook = NULL;
	}
}

//-------------------------------------------------------------------------------------
LPCSTR pluginInfo (int field){
	switch (field){
		case 0: return szVersion;
		case 1: return szAppName;
		case 2: return szInfoVersion;
		case 3: return szInfoAuthor;
		case 4: return szInfoRelDate;
		case 5: return szInfoLink;
		case 6: return szInfoEmail;
	}
	return NULL;
}
